apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: node-scan
  namespace: {{ buildns }}
spec:
  params:
  - default: {{ npmjs_registry }}
    description: NPMJS Repository Endpoint
    name: npmmirror
    type: string
  - default: http://{{ sonarqube_name | default('sonarqube') }}.{{ buildns }}.svc.{{ cluster_domain }}:9000
    description: SonarQube Host URL
    name: sonarhost
    type: string
  - default: ""
    description: SonarQube Password
    name: sonarpassword
    type: string
  - default: Awesome Demo
    description: SonarQube Project Description
    name: sonarprojectdescription
    type: string
  - default: demo
    description: SonarQube Project Name
    name: sonarprojectname
    type: string
  - default: ""
    description: SonarQube Username
    name: sonarusername
    type: string
  steps:
  - args:
    - -c
    - |
        echo "Workspace check:"
        ls -al /workspace || echo no workspace
        ls -al /workspace/.git >/dev/null || echo workspace is not a git
        . /usr/local/bin/set_runtime
        SOURCE_BRANCH=`git branch 2>/dev/null | awk '{print $2}'`
        SOURCE_REPO=`git remote -v 2>/dev/null | awk '{print $2;exit 0;}'`
        SOURCE_REF=`git rev-parse HEAD 2>/dev/null`
        cat <<EOF
        Preparing to scan code ...
        REPO:   $SOURCE_REPO
        BRANCH: $SOURCE_BRANCH
        REF:    $SOURCE_REF
        EOF
        test -d reports || mkdir -p reports
        npm cache clean --force || echo WARNING: cache clean returned non-0
        if test "$(params.npmmirror)"; then
            export NPM_MIRROR=$(params.npmmirror)
        fi
        RUNTIME_IS=unknown
        if test -s ./package.json; then
            if grep ^install: Makefile >/dev/null; then
                make install
            elif test -s ./yarn.lock; then
                yarn install --network-timeout 600000
            else
                npm install --unsafe-perm
            fi
            npm install --unsafe-perm xunit-file mocha expect mock-require
            XUNIT_FILE=reports/TESTS-xunit.xml ./node_modules/.bin/mocha -R xunit-file $(find tests -name '*.js' 2>/dev/null)
            RUNTIME_IS=nodejs
        elif grep php Dockerfile; then
            mkdir -p ./bin
            wget -O ./bin/phpunit https://phar.phpunit.de/phpunit-9.5.phar
            chmod +x ./bin/phpunit
            ./phpunit --log-junit reports/TESTS-xunit.xml tests
            RUNTIME_IS=php
        else
            echo FIXME: could not run unit tests / runtime not recognized
        fi
        npm install --unsafe-perm sonarqube-scanner
        if test "$(params.sonarpassword)" -a "$(params.sonarusername)"; then
            echo "sonar.password=$(params.sonarpassword)" >>sonar-project.properties
            echo "sonar.login=$(params.sonarusername)" >>sonar-project.properties
        fi
        echo sonar credentials not found for $(params.sonarhost), reporting anonymously
        echo "sonar.exclusions=node_modules/** docs/**" >sonar-project.properties
        echo sonar.host.url=$(params.sonarhost) >>sonar-project.properties
        echo sonar.links.homepage=$SOURCE_REPO >>sonar-project.properties
        echo sonar.links.issue=$SOURCE_REPO/issues >>sonar-project.properties
        echo sonar.projectDescription=$(params.sonarprojectdescription) >>sonar-project.properties
        echo sonar.projectKey=$(params.sonarprojectname) >>sonar-project.properties
        echo sonar.projectName=$(params.sonarprojectname) >>sonar-project.properties
        echo sonar.projectVersion=$SOURCE_BRANCH >>sonar-project.properties
        echo sonar.sources=./ >>sonar-project.properties
        if test "$RUNTIME_IS" = php; then
            echo sonar.php.tests.reportPath=reports/TESTS-xunit.xml >>sonar-project.properties
        fi
        if test -d tests; then
            echo sonar.tests=tests >>sonar-project.properties
            echo "sonar.test.exclusions=tests/**" >>sonar-project.properties
        elif test -d test; then
            echo sonar.tests=test >>sonar-project.properties
            echo "sonar.test.exclusions=test/**" >>sonar-project.properties
        fi
        JAVA_TOOL_OPTIONS='-XX:+UnlockExperimentalVMOptions -Dsun.zip.disableMemoryMapping=true' ./node_modules/.bin/sonar-scanner || true
    command:
    - /bin/sh
{% if proxy_host | default(False) %}
    env:
    - name: http_proxy
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: https_proxy
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: no_proxy
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
    - name: HTTP_PROXY
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: HTTPS_PROXY
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: NO_PROXY
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
    env:
    - name: http_proxy
      value: {{ squid_address }}
    - name: https_proxy
      value: {{ squid_address }}
    - name: no_proxy
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
    - name: HTTP_PROXY
      value: {{ squid_address }}
    - name: HTTPS_PROXY
      value: {{ squid_address }}
    - name: NO_PROXY
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% endif %}
    image: {{ (opsimages | json_query("[?name=='jkagsonar'].image"))[0] }}
    name: build
{% if tekton_uses_resources_limits | default(False) %}
    resources:
      limits:
        cpu: "{{ tekton_sonar_scan_cpu_limit }}"
        memory: {{ tekton_sonar_scan_memory_limit }}
      requests:
        cpu: "{{ tekton_sonar_scan_cpu_request }}"
        memory: {{ tekton_sonar_scan_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
{% if 0 == 1 %}
      runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      privileged: true
{% endif %}
{% endif %}
    workingDir: "$(workspaces.source.path)"
  workspaces:
  - name: source
